variable "projects" {
  type = map(object({
    name                                             = string
    namespace_id                                     = number
    allow_merge_on_skipped_pipeline                  = optional(bool, false)
    analytics_access_level                           = optional(string, "enabled")
    approvals_before_merge                           = optional(number, 0)
    archive_on_destroy                               = optional(bool, null)
    archived                                         = optional(bool, false)
    auto_cancel_pending_pipelines                    = optional(string, "enabled")
    auto_devops_deploy_strategy                      = optional(string, "continuous")
    auto_devops_enabled                              = optional(bool, false)
    autoclose_referenced_issues                      = optional(bool, true)
    avatar                                           = optional(string, null)
    build_git_strategy                               = optional(string, "fetch")
    build_timeout                                    = optional(number, 3600)
    builds_access_level                              = optional(string, "enabled")
    ci_config_path                                   = optional(string, "")
    ci_default_git_depth                             = optional(number, 20)
    ci_forward_deployment_enabled                    = optional(bool, true)
    ci_separated_caches                              = optional(bool, true)
    container_registry_access_level                  = optional(string, "enabled")
    default_branch                                   = optional(string, "main")
    description                                      = optional(string, "")
    emails_disabled                                  = optional(bool, false)
    environments_access_level                        = optional(string, "enabled")
    external_authorization_classification_label      = optional(string, "")
    feature_flags_access_level                       = optional(string, "enabled")
    group_with_project_templates_id                  = optional(number, null)
    import_url                                       = optional(string, null)
    import_url_username                              = optional(string, null)
    import_url_password                              = optional(string, null)
    infrastructure_access_level                      = optional(string, "enabled")
    initialize_with_readme                           = optional(bool, null)
    issues_access_level                              = optional(string, "enabled")
    issues_enabled                                   = optional(bool, true)
    issues_template                                  = optional(string, "")
    keep_latest_artifact                             = optional(bool, true)
    lfs_enabled                                      = optional(bool, true)
    merge_commit_template                            = optional(string, "")
    merge_method                                     = optional(string, "merge")
    merge_pipelines_enabled                          = optional(bool, false)
    merge_requests_access_level                      = optional(string, "enabled")
    merge_requests_enabled                           = optional(bool, true)
    merge_requests_template                          = optional(string, "")
    merge_trains_enabled                             = optional(bool, false)
    mirror                                           = optional(bool, null)
    mirror_overwrites_diverged_branches              = optional(bool, null)
    mirror_trigger_builds                            = optional(bool, null)
    monitor_access_level                             = optional(string, "enabled")
    only_allow_merge_if_all_discussions_are_resolved = optional(bool, false)
    only_allow_merge_if_pipeline_succeeds            = optional(bool, false)
    only_mirror_protected_branches                   = optional(bool, null)
    packages_enabled                                 = optional(bool, true)
    pages_access_level                               = optional(string, "enabled")
    path                                             = optional(string)
    printing_merge_request_link_enabled              = optional(bool, true)
    public_jobs                                      = optional(bool, true)
    releases_access_level                            = optional(string, "enabled")
    remove_source_branch_after_merge                 = optional(bool, true)
    repository_access_level                          = optional(string, "enabled")
    request_access_enabled                           = optional(bool, false)
    requirements_access_level                        = optional(string, null)
    resolve_outdated_diff_discussions                = optional(bool, false)
    restrict_user_defined_variables                  = optional(bool, false)
    security_and_compliance_access_level             = optional(string, "private")
    shared_runners_enabled                           = optional(bool, false)
    snippets_access_level                            = optional(string, "enabled")
    snippets_enabled                                 = optional(bool, true)
    squash_option                                    = optional(string, "default_off")
    template_name                                    = optional(string, null)
    template_project_id                              = optional(number, null)
    use_custom_template                              = optional(bool, null)
    topics                                           = optional(list(string), null)
    visibility_level                                 = optional(string, "private")
    wiki_access_level                                = optional(string, "enabled")
    wiki_enabled                                     = optional(bool)
  }))
}
